
hirom
header

org $C256C1
JSR tweak

org $C2571C
JSR tweak

org $C34FDA
JSR _514D

org $C3508F
JSR _514D

org $C35024
JSR _51B9

org $C35063
JSR _51B9

org $C25736
tweak:
PHA    ; save MP cost for now
LDA $F8
ASL A   ; economizer equipped?
BPL check_gold2  ; branch if not
PLA    ; MP cost
LSR A  ; 50% reduction
BRA tweak2  ; branch to make 75% reduction

check_gold2:
ASL A   ; gold hairpin equipped?
ASL A
PLA     ; MP cost
BCC minimum  ; branch if not
tweak2:
INC A  ; round up
LSR A  ; 50% reduction
minimum:
BNE no3    ; branch if MP cost is at least 1
INC A
no3:
RTS

org $C3510D
; this is the whole routine to get the MP cost
INC A
BNE spell    ; branch if it's a spell
TDC    ; clean upper A
LDX $00   ; this is to prevent null spells as having 1 MP cost
RTS

spell:
DEC A
PHA
JSR $50F5
LDX $2134
LDA $C46AC5,X
STA $E0    ; save MP cost
PLA
CMP #$99
BNE not_stepmine
LDA $021B
ASL A
STA $E0
LDA $021C
CMP #$1E
BCC no_inc
INC $E0
no_inc:
not_stepmine:
TDC
LDA $E0   ; MP cost
PHA
LDA $11D7
ASL A   ; economizer equipped?
BPL check_gold ; branch if not
PLA    ; MP cost
LSR A  ; 50% reduction
BRA more  ; branch to make 75% reduction

check_gold:
ASL A   ; gold hairpin equipped?
ASL A
PLA     ; MP cost
BCC minimum2  ; branch if not
more:
INC A  ; round up
LSR A  ; 50% reduction
minimum2:
BNE no    ; branch if MP cost is at least 1
INC A
no:
TAX
RTS

_514D:
CMP #$2A   ; is spell Warp?
BEQ yes_warp
_5155:
JSR $50F5
LDX $2134
LDA $C46AC3,X
LSR A
BCC _51B9
JSR $50EC
JSR $510D
BRA _5188
yes_warp:
STA $E3
LDA $0201    ; load availability
BIT #$02     ; is warp able?
BEQ _51B9    ; branch if not
LDA $E3
BRA _5155
_5188:
STX $E2
JSR $4EDD
LDA $0014,Y   ; status byte 1
AND #$20      ; imp?
BEQ _519B     ; branch if not
JSR $50EC
CMP #$23
BNE _51B9
_519B:
REP #$20
LDA $000D,Y    ; current MP
STA $E0    ; save
SEP #$20
LDX $E2    ; MP cost of current spell
CPX $E0    ; compare to current MP
BEQ _51AC
BCS _51B9
_51AC:
TDC
LDA $E5
TAX
LDA #$20    ; set text color to white
finish_magic:
STA $29
STA $7E9E09,X
RTS
_51B9:
TDC
LDA $E5
TAX
LDA #$28    ; set text color to gray
BRA finish_magic

padbyte $FF : pad $C351C6
